#!perl

# $Id: install.pl,v 1.23 2008/04/06 14:16:39 maeda Exp $

# Copyright 2008 by Kaoru Maeda <kaoru.maeda@gmail.com>
#
# This program is free software; you may redistribute it and/or modify it
# under the same terms as Perl itself.

use strict;
use File::Spec;
use Cwd 'abs_path';
use Config;
use Encode;
use Win32;
our $C;

# g
#  1. config_default.plconfig.plɃRs[
#  2. config.pl̐ݒ荀ڂKvɉĕύX
#  2. install.pl_uNbN
#  3. CXg[Ŏs鏈\̂ŁA
#     sėǂ΃^[A~ȂRg[CŎ~߂Ă

my @errors;

open LOG, ">>install_log.txt";
select LOG; $| = 1;
select STDOUT; $| = 1;
message(("-" x 60) . "\n");
message("CXg[Jn: " . scalar(localtime()) . "\n");

my $homedir = slashize(abs_path());
my $homedir_d = backslashize($homedir);
$C->{Home} = $homedir_d;

require "$homedir/values.pl";
eval {
    require "$homedir/config.pl"; # override with user config values
};
if ($@) {
    push(@errors, "cofig.pl̏Ɍ肪܂\n");
    error_check();
    # NOTREACHED
}

my @what_to_do;
my %overwrite;
our $sedir = slashize($C->{SoundEngine}{ConfigDir});

# Sound Enginẽ`FbN
if ($C->{UseSoundEngine}) {
    my @scripts = qw(Sec/psyenc.sec Ses/psyenc.ses Ses/psyenc-vid.ses);
    if (-d $sedir) {
	for my $f (@scripts) {
	    $overwrite{$f} = (-f "$sedir/$f") ? '㏑' : "";
	}
    } else {
	push(@errors, <<EOL);
Sound Engine̐ݒtH_܂
  Sound Engine̓CXg[܂?
  install.pl\$sedir𐳂ݒ肵ĂB
  ݂̐ݒl: $sedir
EOL
	;
    }
}

# Kvȃt@Č

my @necessary_files = qw(ffmpeg.exe pthreadGC2.dll swfextract.exe);
$C->{UseWaveGain} and push(@necessary_files, "wavegain.exe");
for my $f (@necessary_files) {
    unless (-f $f) {
	push(@errors, "$f  $homedir_d ɒuĂ\n");
    }
}

# ꎞtH_̌

my $tmpdir = slashize($C->{TmpDir});
unless (-d $tmpdir) {
    mkdir $tmpdir, 0777;
    unless (-d $tmpdir) {
	push(@errors, "ꎞtH_ $C->{TmpDir} 쐬ł܂\n");
    }
}

# PerloCǐ
my $perlse = "$sedir/perl.exe";
my $perlbindir = $Config{bin};
my $perlsrc = "$perlbindir/perl.exe";
if (!perl_ok()) {
    push(@what_to_do, [<<EOL, \&copy_perl]);
perl.exe  $sedir ɃRs[܂
EOL
    ;
}

# PerlW[̌

my @modules = (
	       [ 'MP3::Info', 1.23 ],
	       [ 'MP4::Info', 1.11 ],
	       [ 'MP3::Tag',  0.97 ],
	       );
my @need_modules = missing_modules(@modules);

unless (@need_modules == 0) {
    my $mm = join(", ", map {$_->[0].$_->[1]} @need_modules);
    push (@what_to_do, [<<EOL, \&install_modules]);
ȉPerlW[ ActiveState _E[h
  CXg[܂:
    $mm
EOL
    ;
}

sub install_modules {
    for my $m (@need_modules) {
	my $ppm_modname = $m->[0];
	$ppm_modname =~ s/::/-/g;
	run("ppm install $ppm_modname");
    }
    my @still_missing = missing_modules(@need_modules);
    if (@still_missing) {
	my $mm = join(", ", map {$_->[0] . ($_->[1] ? "(Found $_->[1])" : "")} @still_missing);
	push (@errors, <<EOL);
ȉ̃W[CXg[łȂÂł:
    $mm
  vLVgĂꍇ͈ȉ̊ϐmFĂ:
    HTTP_proxy, HTTP_proxy_user, HTTP_proxy_pass
EOL
	;
    }
}

# ɃG[͂?
error_check();

# Ȃ΂邱ƃXg쐬
push (@what_to_do,
      [<<EOL, sub { temp_copy("psyenc.pl_", "psyenc.pl") }],);
psyenc.plɐݒl𔽉f܂
EOL
if ($C->{UseSoundEngine}) {
    push(@what_to_do,
	 [<<EOL, sub { temp_copy2("psyenc.s_s", "psyenc.ses", "$sedir/Ses/psyenc.ses") }],
ꊇϊXNvgSound Engine$overwrite{"Ses/psyenc.ses"}CXg[܂
    $sedir/Ses/psyenc.ses
EOL
	 [<<EOL, sub { temp_copy2("psyenc-vid.s_s", "psyenc-vid.ses", "$sedir/Ses/psyenc-vid.ses") }],
rfIꊇϊXNvgSound Engine$overwrite{"Ses/psyenc-vid.ses"}CXg[܂
    $sedir/Ses/psyenc-vid.ses
EOL
	 [<<EOL, sub { temp_copy2("psyenc.s_c", "psyenc.sec", "$sedir/Sec/psyenc.sec") }],
`ϊR}hCSound Engine$overwrite{"Sec/psyenc.sec"}CXg[܂
    $sedir/Sec/psyenc.sec
EOL
	);
}

# sĂ?
message("ȉ̏s܂:\n");
for my $w (@what_to_do) {
    message("  " . $w->[0]);
}

message("낵ł?
  OKȂ烊^[ACXg[~Ȃ
  n܂CTRL-ĆA邢͂̑ [Y/n]: ");
my $ans = <STDIN>;
if ($ans =~ /n/i) {
    message("\n~܂B\n");
    pause();
    exit(1);
}

# CXg[s
message("\nCXg[Jn܂B\n");
for my $w (@what_to_do) {
    message($w->[0]);
    $w->[1]();
    error_check();
}

error_check();

message("܂\n");
pause();
exit(0);

# ȉTu[`

sub run {
    my $cmd = shift;
    message("$cmd\n");
    system($cmd);
}

sub message {
    print STDOUT $_[0];
    print LOG $_[0];
}

sub pause {
    message("^[L[Ă: ");
    my $ans = <STDIN>;
}

sub missing_modules {
    my @missing;
    for my $m (@_) {
	my ($modname, $reqver) = @$m;
	my $found = eval qq[require $modname; \$${modname}\::VERSION];
	if ($@) {
	    push @missing, [$modname, ""];
	} elsif ($found < $reqver) {
	    push @missing, [$modname, " (Found $found; Need $reqver)"];
	}
    }
    @missing;
}

sub error_check {
    if (@errors) {
	for (@errors) {
	    message($_);
	}
	message("I܂B\n");
	pause();
	exit(1);
    }
}

sub perl_ok {
    -s $perlsrc == -s $perlse;
}

sub copy_perl {
    use File::Copy;
    copy($perlsrc, $perlse);
    if (!perl_ok()) {
	push(@errors, <<EOL);
perl.exe ̃Rs[Ɏs܂
  perl.exe $sedir Ɏ蓮ŃRs[AĎsĂ
EOL
	;
    }
}

sub temp_copy2 {
    use File::Copy;
    my ($src, $here, $dst) = @_;
    temp_copy($src, $here);
    @errors and return;
    if (!copy($here, $dst)) {
	push(@errors, <<EOL);
$dst 쐬ł܂
EOL
    }
}

sub temp_copy {
    my ($src, $dst) = @_;
    my $mp3ext = $C->{SoundEngine}{UsePsyencForMP3Decode} ? 'mp3' : 'mp3p';
    eval {
	open IN, "<$src" or die "$src ǂݍ߂܂\n";
	open OUT, ">$dst" or die "$dst 쐬ł܂\n";
	while (<IN>) {
	    if (/\%AUTOMAXSHOW\%/) {
		if ($C->{SoundEngine}{ShowAutoMaxDialog}) {
		    $_ = qq[Option=ShowOnce\n];
		} else {
		    $_ = '';
		}
	    }
	    s/\%HOMEDIR\%/$homedir_d/;
	    s/\%TMPDIR\%/$tmpdir/;
	    s/\%AUTOMAXLEVEL\%/$C->{SoundEngine}{AutoMaxLevel}/;
	    s/\%MP3EXTBYPSYENC\%/$mp3ext/;
	    s/\%AVIARGS\%/$C->{Format}{"avi"}{FFMpeg}/;
	    s/\%3GPARGS\%/$C->{Format}{"3gp"}{FFMpeg}/;
	    s/\%MP4VARGS\%/$C->{Format}{"mp4"}{FFMpeg}/;
	    s/\%VIDTYPE\%/$C->{DefaultOutputFormat}/;
	} continue {
	    print OUT or  die "$dst ɏ߂܂\n";
	}
	    ;
	close IN;
	close OUT or die  "$dst ɏ߂܂\n";
    };
    if ($@) {
	push (@errors, $@);
	unlink $dst;
    }
}

sub backslashize {
    pathdelim_convert($_[0], 'back');
}

sub slashize {
    pathdelim_convert($_[0], 'slash');
}

sub pathdelim_convert {
    my ($src, $dir) = @_;
    my $usrc = decode('sjis', $src);
    if ($dir eq 'back') {
	$usrc =~ s[/][\\]g;
    } elsif ($dir eq 'slash') {
	$usrc =~ s[\\][/]g;
    }
    encode('sjis', $usrc);
}
